(load "FantasticFour.scm")

(write "Creating lol (a canteen)") (newline)

(define lol 
	(Create-Canteen '(3 6 7) 
	'((4 5 10) 
		(4 5 11) 
		(8 2 9) 
		(8 2 6) 
		(9 1 2) 
		(9 1 5) 
		(9 3 2) 
		(9 3 7))))

(define pol
	(Create-Canteen '(1 2 3)
	'((1 3 4)
		(1 6 4)
		(1 9 9)
		(2 3 4)
		(2 7 4)
		(3 7 8)
		(3 7 9)
		(8 6 9))))

(write "lol = ") (newline)
(pp lol) (newline)

(write "pol = ") (newline)
(pp pol) (newline)

(write "(get-sub-canteen '(3 6) lol) =") (newline)
(pp (get-sub-canteen '(3 6) lol)) (newline) (newline)

(write "(get-sub-canteen '(3 7) lol) =") (newline)
(pp (get-sub-canteen '(3 7) lol)) (newline) (newline)

(write "(filter1 (cadr (get-sub-canteen '(3 7) lol)) '((4 10) (8 6) (9 2))) =") 
(newline)
(pp (filter1 (cadr (get-sub-canteen '(3 7) lol)) '((4 10) (8 6) (9 2)))) 
(newline) (newline)

(write "(filter1 (cadr (get-sub-canteen '(3 7) lol)) '()) =") 
(newline)
(pp (filter1 (cadr (get-sub-canteen '(3 7) lol)) '())) 
(newline) (newline)

(define meh (get-sub-canteen '(3) lol))

(define blockMeh (blockerize (cadr meh)))

(write "(blockerize (cadr meh)) =") 
(newline)
(pp blockMeh) 
(newline) (newline)

(define beh (get-sub-canteen '(3) pol))
(define blockBeh (blockerize (cadr beh)))

(write "(blockerize (cadr beh)) =") 
(newline)
(pp blockBeh) 
(newline) (newline)

(write "(block-matcher blockBeh blockMeh cons) =") 
(newline)
(pp (block-matcher blockBeh blockMeh (lambda (x y) (cons x (list y))))) 
(newline) (newline)

; Need to test combine

(write "(combine '(1 2 3 4) '() '(1 2 3 4) '()) = ")
(newline)
(write (combine '(1 2 3 4) '() '(1 2 3 4) '()))
(newline) (newline)

(write "(combine '() '(1 2 3 4) '() '(1 2 3 4)) = ")
(newline)
(write (combine '() '(1 2 3 4) '() '(1 2 3 4)))
(newline) (newline)

(write "(combine '(1 2 4 5 6) '(3 4 6 7 8 9) '(1 2 4 5 6) '(3 4 6 7 8 9)) = ")
(newline)
(write (combine '(1 2 4 5 6) '(3 4 6 7 8 9) '(1 2 4 5 6) '(3 4 6 7 8 9)))
(newline) (newline)

(define superman (apply append (block-matcher blockBeh blockMeh (lambda (x y) (block-multiply (cdr x) (cdr y) '(1 2 3) '(3 6 7))))))

(write "(apply append (block-matcher blockBeh blockMeh (lambda (x y) (block-multiply (cdr x) (cdr y) '(1 2 3) '(3 6 7))))) =") 
(newline)
(pp superman) 
(newline) (newline)

(write "(Create-Trie superman) =") 
(newline)
(pp (Create-Trie superman)) 
(newline) (newline)

(write "(Join-Canteens lol pol (lambda (x y z) #t)) =") 
(newline)
(pp (Join-Canteens lol pol (lambda (x y z) #t))) 
(newline) (newline)

(define (pred1 x y z) 
	(<= (+ x y z) 5))

(define (pred2 x y z)
	(<= (+ (* x x) (* y y) (* z z)) 10))

(define myInitList
	'((1 2 3 4) (1 2 3 4) (1 2 3 4)))

(write "(prune-points myInitList (list (cons (list 0 1 2) (list pred1))))") (newline)
(newline)
(pp (prune-points myInitList 
									(list (cons (list 0 1 2) 
															(list pred1)))))
(newline) (newline)

; result: 
; ((0 1 2) 
;	 ((1 ((1 ((1) 
;						(2) 
;						(3))) 
;				(2 ((1) 
;						(2))) 
;				(3 ((1))))) 
;		(2 ((1 ((1) 
;						(2))) 
;				(2 ((1)))))))

(write "(prune-points myInitList (list (cons (list 0 1 2) (list pred1))))") (newline)
(newline)
(pp (prune-points myInitList 
									(list (cons (list 0 1 2) 
															(list pred1))
												(cons (list 0 1 2)
															(list pred2)))))
(newline) (newline)

; result:
; ((0 1 2) 
;	 ((1 ((1 ((1) 
;						(2))) 
;				(2 ((1) 
;						(2))))) 
;		(2 ((1 ((1) 
;						(2)))))))

(define myInitList2
	'((1 2 3 4) (1 2 3 4) (1 2 3 4) (1 2 3 4)))

(write "(prune-points myInitList2 (list (cons (list 0 1 2) (list pred1))))") (newline)
(newline)
(pp (prune-points myInitList2 
									(list (cons (list 0 1 2) 
															(list pred1))
												(cons (list 1 2 3)
															(list pred2)))))
(newline) (newline)

;((1 2 3 4)
;	((1 ((1 ((1 ((1) 
;							 (2)))
;					 (2 ((1) 
;							 (2)))))
;  	   (2 ((1 ((1) 
;			 				 (2)))))))
;	 (2 ((1 ((1 ((1) 
;							 (2)))
;					 (2 ((1) 
;							 (2)))))
;			 (2 ((1 ((1) 
;							 (2)))))))
;	 (3 ((1 ((1 ((1) 
;							 (2)))))))))

